
// 获取系统配置信息
function getFirmInfo() {
	axios.post('').then(res => {
		if (res.code === 100001) {
			getApp().globalData.firmData = res.data
			store.commit('setTabBar', res.data.newMiniProgramFooterNav.list)
		}
	})
}
// 获取系统配置信息
function getSiteInfo() {
	return new Promise((resolve, reject) => {
		axios.get(api.site, {
		}, {
		}).then(res => {
			resolve(res)
		}, err => {
			reject(err)
		})
	})
}
 // 获取用户位置坐标
 function getLocation() {
	 console.log(1111)
	return new Promise((resolve, reject) => {
		if (getApp() && getApp().globalData.userLocation) {
			resolve(true)
			return
		} 
		// 获取用户坐标
		uni.getLocation({
			type:'gcj02',
			success: res => {
				console.log(res)
				this.lonToAddress(res.latitude, res.longitude).then(res => {
					let location=res.addressComponent.streetNumber.location.split(',');
					getApp().globalData.userLocation = {
						address: res.formatted_address,
						latitude: location[1],
						longitude: location[0],
						currentAddress:res.addressComponent.district.replace('市','')
					}
					resolve(true)
				})
				
			},
			fail: err => {
				console.log(err)
				resolve(false)
			}
		})
	})
}
//赠送优惠券
function setShopStorePrivilege(data) {
	return new Promise((resolve, reject) => {
		axios.post(api.setShopStorePrivilege, {
			productSknId: data.productSknId,
			userid: data.userid,
			uid: data.uid,
			storeId: data.storeId,
		}, {
			baseURL: 'url'
		}).then(res => {
			resolve(res)
		}, err => {
			reject(err)
		})
	})
}
// 根据定位换取地址信息
function lonToAddress(lat, lng) {
	return new Promise((resolve, reject) => {
		uni.request({
			url: `https://restapi.amap.com/v3/geocode/regeo?key=81b0304f38f2178cc7ece5b5c537c741&location=${lng},${lat}`,
			success: res => {
				resolve(res.data.regeocode)
			},
			fail: err => {
				reject(err)
			}
		})
	})
}
//调起微信支付
function newCreate_order(data) {
	return new Promise((resolve, reject) => {
		let openId=JSON.parse(uni.getStorageSync('userInfo')).openId
		axios.post(api.newCreate_order, {
			orderId: data.orderId,
			consumerId: openId,
			type: 3,
			orgId: 22,
		}, {
			baseURL: 'payURL'
		}).then(res => {
			resolve(res)
		}, err => {
			reject(err)
		})
	})
}
//获取支付宝id
function getZfbId(data) {
	return new Promise((resolve, reject) => {
		axios.post(api.getZfbId, {
			authCode: data,
		}, {
			baseURL: 'payURL'
		}).then(res => {
			resolve(res)
			getApp().globalData.zfbUserId = res.data
			
		}, err => {
			reject(err)
		})
	})
}
//支付宝支付
function zfbPay(data) {
	return new Promise((resolve, reject) => {
		let buyerId=getApp().globalData.zfbUserId;
		console.error(getApp().globalData);
		axios.post(api.aliPay, {
			orderCode: data,
			buyerId:buyerId
		}, {
			baseURL: 'payURL'
		}).then(res => {
			resolve(res)
		}, err => {
			reject(err)
		})
	})
}
//字节小程序支付
function pay_tt(data) {
	return new Promise((resolve, reject) => {
		let openId=JSON.parse(uni.getStorageSync('userInfo')).openId
		axios.post(api.pay, {
			orderId: data.orderId,
			consumerId: openId,
			type: 3,
			orgId: 22,
			payChannelType:data.payChannelType
		}, {
			baseURL: 'payURL'
		}).then(res => {
			resolve(res)
		}, err => {
			reject(err)
		})
	})
}
//获取微信code码
function getCodeUrl(data) {
	return new Promise((resolve, reject) => {
		axios.post(api.getWxCodeUrl, {
			storeId: data.storeId,
			code: data.code,
		}, {
			baseURL: 'adminUrl'
		}).then(res => {
			resolve(res)
		}, err => {
			reject(err)
		})
	})
}
// 获取系统信息
function getSystemInfo() {
	return new Promise((resolve, reject) => {
		if (getApp() && getApp().globalData.titleBarHeight && getApp().globalData.statusBarHeight) {
			resolve()
			return
		}
		uni.getSystemInfo({
		  success: (res) => {
			// model设备型号
			// iOS
			// 标题栏高度
			if (res.model.indexOf('iPhone') !== -1) {
				getApp().globalData.titleBarHeight = 40
			} else {
				getApp().globalData.titleBarHeight =  48
			  // android
			}
			// 状态栏高度
			getApp().globalData.statusBarHeight = res.statusBarHeight
			resolve()
		  }
		})
	})
}
// 清空用户信息
function clearUserInfo() {
	uni.removeStorage({ // 清除缓存
		key: 'userInfo'
	})
	store.commit('setToken', '') // 清除vuex管理器中的token
	store.commit('setMId', '') // 清除vuex管理器中的mid
	getApp().globalData.userInfo = null
}
// get地址拼接
function paramsToUrl(url, params = {}) {
	if (!params) return url
	let arr = []
	Object.keys(params).forEach(item => {
		arr.push(`${item}=${params[item]}`)
	})
	
	return `${url}${url.includes('?') ? '&' : '?'}${arr.join('&')}`
}
//获取H5链接参数
function getUrlCode(name){
	var reg = new RegExp("(^|&)"+ name +"=([^&]*)(&|$)");
   var r = window.location.search.substr(1).match(reg);
   if(r!=null)return unescape(r[2]); return null;
}

//门店跳转
function storeJump(index,id){
	switch(Number(index)){
		case 0 ://全部商品
			uni.navigateTo({
				url:'/pages/shop/shop-detail/index?id=' + id
			})
		break; 
		case 1 ://红包商城
			uni.navigateTo({
				url:'/shop/pages/envelopesMall/index?id=' + id
			})
		break; 
		case 2 ://门店优惠
			uni.navigateTo({
				url:'/shop/pages/storeDiscount/index?id=' + id
			})
		break;
		case 3 ://会员充值
			uni.navigateTo({
				url:'/shop/pages/memberRecharge/balance?id='+ id
			})
		break;
		case 4 ://爆品抢购
			uni.navigateTo({
				url:'/shop/pages/storeRush/index?id=' + id
			})
		break;
		case 5 ://会员商城
			uni.navigateTo({
				url:'/shop/pages/boutiqueMall/index?id=' + id
			})
		break;
		case 6 :
			uni.navigateTo({
				url:''
			})
		break;
		case 7 :
			uni.navigateTo({
				url:''
			})
		break;
	}
}
//会员权益跳转
function agreement(){
	let url = 'https://tslm.cvtvcn.com/quanyi'
	uni.navigateTo({
		url:`/pages/public/webview/webview?title=会员权益&url=${url}`
	})
}


export default {
	clearUserInfo, // 清除全站用户信息，退出登录或登录失效
	getLocation, // 获取用户位置坐标
	lonToAddress, // 根据定位换取地址信息
	getFirmInfo,  // 获取站点信息
	getSystemInfo, // 获取系统信息
	paramsToUrl, // 地址拼接
	newCreate_order,//调起微信支付
	getSiteInfo,
	pay_tt,
	getUrlCode,
	getZfbId,
	zfbPay,
	getCodeUrl,
	setShopStorePrivilege,
	storeJump,
	agreement
}
			